import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import PropTypes from 'prop-types';
import React from 'react';
import { InputGroupAddon, InputGroupText, FormFeedback, Label, FormText, FormGroup, Input, InputGroup, Form } from 'reactstrap';
import { DataMap } from 'lemo-object';

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }

  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}

function _asyncToGenerator(fn) {
  return function () {
    var self = this,
        args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);

      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }

      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }

      _next(undefined);
    });
  };
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function _objectSpread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    var ownKeys = Object.keys(source);

    if (typeof Object.getOwnPropertySymbols === 'function') {
      ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) {
        return Object.getOwnPropertyDescriptor(source, sym).enumerable;
      }));
    }

    ownKeys.forEach(function (key) {
      _defineProperty(target, key, source[key]);
    });
  }

  return target;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};

  var target = _objectWithoutPropertiesLoose(source, excluded);

  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

var FieldAddonAppend =
/*#__PURE__*/
function (_React$Component) {
  _inherits(FieldAddonAppend, _React$Component);

  function FieldAddonAppend() {
    _classCallCheck(this, FieldAddonAppend);

    return _possibleConstructorReturn(this, _getPrototypeOf(FieldAddonAppend).apply(this, arguments));
  }

  _createClass(FieldAddonAppend, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          icon = _this$props.icon,
          text = _this$props.text;

      if (!icon && !text) {
        return '';
      }

      var content = text;

      if (icon) {
        content = React.createElement(FontAwesomeIcon, {
          icon: icon,
          fixedWidth: true
        });
      }

      return React.createElement(InputGroupAddon, {
        addonType: "append"
      }, React.createElement(InputGroupText, null, content));
    }
  }]);

  return FieldAddonAppend;
}(React.Component);

FieldAddonAppend.propTypes = {
  icon: PropTypes.oneOfType([PropTypes.object, PropTypes.array, PropTypes.string]),
  text: PropTypes.string
};

var FieldAddonPrepend =
/*#__PURE__*/
function (_React$Component) {
  _inherits(FieldAddonPrepend, _React$Component);

  function FieldAddonPrepend() {
    _classCallCheck(this, FieldAddonPrepend);

    return _possibleConstructorReturn(this, _getPrototypeOf(FieldAddonPrepend).apply(this, arguments));
  }

  _createClass(FieldAddonPrepend, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          icon = _this$props.icon,
          text = _this$props.text;

      if (!icon && !text) {
        return '';
      }

      var content = text;

      if (icon) {
        content = React.createElement(FontAwesomeIcon, {
          icon: icon,
          fixedWidth: true
        });
      }

      return React.createElement(InputGroupAddon, {
        addonType: "prepend"
      }, React.createElement(InputGroupText, null, content));
    }
  }]);

  return FieldAddonPrepend;
}(React.Component);

FieldAddonPrepend.propTypes = {
  icon: PropTypes.oneOfType([PropTypes.object, PropTypes.array, PropTypes.string]),
  text: PropTypes.string
};

var FieldFeedback =
/*#__PURE__*/
function (_React$Component) {
  _inherits(FieldFeedback, _React$Component);

  function FieldFeedback() {
    _classCallCheck(this, FieldFeedback);

    return _possibleConstructorReturn(this, _getPrototypeOf(FieldFeedback).apply(this, arguments));
  }

  _createClass(FieldFeedback, [{
    key: "render",
    value: function render() {
      var error = this.props.error;

      if (!error) {
        return '';
      }

      return React.createElement(FormFeedback, null, error);
    }
  }]);

  return FieldFeedback;
}(React.Component);

FieldFeedback.propTypes = {
  error: PropTypes.string
};

var defaultProps = {
  required: false
};
var propTypes = {
  name: PropTypes.string,
  required: PropTypes.bool,
  text: PropTypes.string
};

var FieldLabel =
/*#__PURE__*/
function (_React$Component) {
  _inherits(FieldLabel, _React$Component);

  function FieldLabel() {
    _classCallCheck(this, FieldLabel);

    return _possibleConstructorReturn(this, _getPrototypeOf(FieldLabel).apply(this, arguments));
  }

  _createClass(FieldLabel, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          name = _this$props.name,
          required = _this$props.required,
          text = _this$props.text;

      if (!text) {
        return '';
      }

      if (!required) {
        return React.createElement(Label, {
          for: name
        }, text);
      }

      return React.createElement(Label, {
        for: name
      }, text, " ", React.createElement("em", {
        className: "required"
      }, "*"));
    }
  }]);

  return FieldLabel;
}(React.Component);

FieldLabel.defaultProps = defaultProps;
FieldLabel.propTypes = propTypes;

var FieldText =
/*#__PURE__*/
function (_React$Component) {
  _inherits(FieldText, _React$Component);

  function FieldText() {
    _classCallCheck(this, FieldText);

    return _possibleConstructorReturn(this, _getPrototypeOf(FieldText).apply(this, arguments));
  }

  _createClass(FieldText, [{
    key: "render",
    value: function render() {
      var text = this.props.text;

      if (!text) {
        return '';
      }

      return React.createElement(FormText, null, text);
    }
  }]);

  return FieldText;
}(React.Component);

FieldText.propTypes = {
  text: PropTypes.string
};

var FormContext = React.createContext();

var withFormApi = function withFormApi(Component) {
  return React.forwardRef(function (props, ref) {
    return React.createElement(FormContext.Consumer, null, function (_ref) {
      var formApi = _ref.formApi;
      return React.createElement(Component, _extends({
        formApi: formApi,
        ref: ref
      }, props));
    });
  });
};

var Field =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Field, _React$Component);

  function Field(props) {
    var _this;

    _classCallCheck(this, Field);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Field).call(this, props));
    _this.state = {
      disabled: props.disabled,
      error: props.formApi.getError(props.name),
      options: props.options,
      required: props.required,
      validatorsEnabled: props.validatorsEnabled,
      value: props.formApi.getValue(props.name),
      visible: props.visible
    };
    _this.handleBlur = _this.handleBlur.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.handleChange = _this.handleChange.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    return _this;
  }

  _createClass(Field, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var formApi = this.props.formApi;
      formApi.set(this.props.name, this);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var formApi = this.props.formApi;
      formApi.remove(this.props.name);
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.disabled !== this.props.disabled) {
        this.setState({
          disabled: nextProps.disabled
        });
      }

      if (nextProps.error !== this.props.error) {
        this.setState({
          error: nextProps.error
        });
      }

      if (nextProps.options !== this.props.options) {
        this.setState({
          options: nextProps.options
        });
      }

      if (nextProps.required !== this.props.required) {
        this.setState({
          required: nextProps.required
        });
      }

      if (nextProps.validatorsEnabled !== this.props.validatorsEnabled) {
        this.setState({
          validatorsEnabled: nextProps.validatorsEnabled
        });
      }

      if (nextProps.value !== this.props.value) {
        this.setState({
          value: nextProps.value
        });
      }

      if (nextProps.visible !== this.props.visible) {
        this.setState({
          visible: nextProps.visible
        });
      }
    }
  }, {
    key: "updateState",
    value: function updateState() {
      var formApi = this.props.formApi;
      this.setState(_objectSpread({}, this.state, {
        error: formApi.getError(this.props.name),
        touched: formApi.getTouched(this.props.name),
        value: formApi.getValue(this.props.name)
      }));
    }
  }, {
    key: "handleBlur",
    value: function handleBlur(e) {
      var formApi = this.props.formApi;
      formApi.setValue(e.target.name, e.target.value);
    }
  }, {
    key: "handleChange",
    value: function handleChange(e) {
      var formApi = this.props.formApi;
      formApi.setValue(e.target.name, e.target.value);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          addonAppendIcon = _this$props.addonAppendIcon,
          addonAppendText = _this$props.addonAppendText,
          addonPrependIcon = _this$props.addonPrependIcon,
          addonPrependText = _this$props.addonPrependText,
          disabledIfEmptyOptions = _this$props.disabledIfEmptyOptions,
          label = _this$props.label,
          name = _this$props.name,
          optionsEmpty = _this$props.optionsEmpty,
          text = _this$props.text,
          type = _this$props.type;
      var _this$state = this.state,
          error = _this$state.error,
          options = _this$state.options,
          required = _this$state.required,
          visible = _this$state.visible;
      var _this$state2 = this.state,
          disabled = _this$state2.disabled,
          value = _this$state2.value;

      if (!visible) {
        return '';
      }

      var field = null;

      switch (type) {
        case 'select':
          if (true === disabledIfEmptyOptions && 0 === options.length) {
            disabled = true;
          }

          if (0 === options.length) {
            value = '';
          }

          field = React.createElement(Input, {
            disabled: disabled,
            invalid: !!error,
            name: name,
            onBlur: this.handleBlur,
            onChange: this.handleChange,
            required: required,
            type: type,
            value: value || ''
          }, optionsEmpty && React.createElement("option", {
            value: ""
          }, "-"), this.renderOptions());
          break;

        default:
          field = React.createElement(Input, {
            disabled: disabled,
            invalid: !!error,
            name: name,
            onBlur: this.handleBlur,
            onChange: this.handleChange,
            required: required,
            type: type,
            value: !value && value !== 0 ? '' : value
          });
      }

      return React.createElement(FormGroup, null, React.createElement(FieldLabel, {
        name: name,
        required: required,
        text: label
      }), React.createElement(InputGroup, null, React.createElement(FieldAddonPrepend, {
        icon: addonPrependIcon,
        text: addonPrependText
      }), field, React.createElement(FieldAddonAppend, {
        icon: addonAppendIcon,
        text: addonAppendText
      }), React.createElement(FieldFeedback, {
        error: error
      })), React.createElement(FieldText, {
        text: text
      }));
    }
  }, {
    key: "renderOptions",
    value: function renderOptions() {
      var _this$props2 = this.props,
          options = _this$props2.options,
          optionsKey = _this$props2.optionsKey,
          optionsValue = _this$props2.optionsValue;
      return options.map(function (option) {
        return React.createElement("option", {
          key: option[optionsKey],
          value: option[optionsKey]
        }, option[optionsValue]);
      });
    }
  }]);

  return Field;
}(React.Component);

Field.defaultProps = {
  addonAppendIcon: null,
  addonAppendText: null,
  addonPrependIcon: null,
  addonPrependText: null,
  disabled: false,
  disabledIfEmptyOptions: true,
  disabledIfInvalid: [],
  options: [],
  optionsEmpty: true,
  required: false,
  requiredIfNotEmpty: [],
  text: null,
  touched: false,
  type: 'text',
  validateIfChange: [],
  validateOnChange: true,
  validators: [],
  validatorsEnabled: true,
  value: '',
  visible: true
};
Field.propTypes = {
  addonAppendIcon: PropTypes.oneOfType([PropTypes.object, PropTypes.array, PropTypes.string]),
  addonAppendText: PropTypes.string,
  addonPrependIcon: PropTypes.oneOfType([PropTypes.object, PropTypes.array, PropTypes.string]),
  addonPrependText: PropTypes.string,
  disabled: PropTypes.bool,
  disabledIfEmptyOptions: PropTypes.bool,
  disabledIfInvalid: PropTypes.array,
  error: PropTypes.string,
  label: PropTypes.string,
  name: PropTypes.string.isRequired,
  onBlur: PropTypes.func,
  onBlurIfValid: PropTypes.func,
  onChange: PropTypes.func,
  onChangeIfValid: PropTypes.func,
  onNormalize: PropTypes.func,
  options: PropTypes.oneOfType([PropTypes.array, PropTypes.object]),
  optionsEmpty: PropTypes.bool,
  optionsKey: PropTypes.string,
  optionsValue: PropTypes.string,
  required: PropTypes.bool,
  requiredIfNotEmpty: PropTypes.array,
  ref: PropTypes.func,
  text: PropTypes.string,
  touched: PropTypes.bool,
  type: PropTypes.string,
  validateIfChange: PropTypes.array,
  validateOnChange: PropTypes.bool,
  validators: PropTypes.array,
  validatorsEnabled: PropTypes.bool,
  visible: PropTypes.bool,
  value: PropTypes.oneOfType([PropTypes.number, PropTypes.string])
};
var Field$1 = withFormApi(Field);

var Form$1 =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Form$$1, _React$Component);

  function Form$$1(props) {
    var _this;

    _classCallCheck(this, Form$$1);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Form$$1).call(this, props));
    _this.state = {
      isHighlightingErrors: false,
      isSubmitting: false
    };
    _this.errors = new DataMap();
    _this.fields = new Map();
    _this.fieldsDisabledIfInvalid = new Map();
    _this.fieldsRequiredIfNotEmpty = new Map();
    _this.fieldsTriggerDisabled = new Map();
    _this.touched = new DataMap();
    _this.values = new DataMap(props.values);

    if (props.onInit) {
      props.onInit(_assertThisInitialized(_assertThisInitialized(_this)));
    }

    _this.get = _this.get.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.getError = _this.getError.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.getErrors = _this.getErrors.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.getTouched = _this.getTouched.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.getValue = _this.getValue.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.getValues = _this.getValues.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.has = _this.has.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.handleChange = _this.handleChange.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.handleSubmit = _this.handleSubmit.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.remove = _this.remove.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.set = _this.set.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.setError = _this.setError.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.setTouched = _this.setTouched.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.setValue = _this.setValue.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    return _this;
  }

  _createClass(Form$$1, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.values !== this.props.values) {
        this.values = new DataMap(nextProps.values);

        if (0 === Object.keys(nextProps.values).length) {
          this.fields.forEach(function (field) {
            field.setState({
              error: null,
              touched: false,
              value: ""
            });
          });
        } else {
          this.fields.forEach(function (field) {
            var fieldName = field.props.name;

            if (nextProps.values.hasOwnProperty(fieldName)) {
              field.setState({
                value: nextProps.values[fieldName]
              });
            }
          });
        }
      }
    }
  }, {
    key: "set",
    value: function set(name, field) {
      var _this2 = this;

      this.fields.set(name, field); // Disabled if not valid

      if (field.props.disabledIfInvalid.length > 0) {
        this.fieldsDisabledIfInvalid.set(name, field.props.disabledIfInvalid);
        field.props.disabledIfInvalid.forEach(function (fieldToCheck) {
          if (!_this2.fieldsTriggerDisabled.has(fieldToCheck)) {
            _this2.fieldsTriggerDisabled.set(fieldToCheck, []);
          }

          _this2.fieldsTriggerDisabled.get(fieldToCheck).push(name);
        });
      } // Required if not empty


      if (field.props.requiredIfNotEmpty.length > 0) {
        this.fieldsRequiredIfNotEmpty.set(name, field.props.requiredIfNotEmpty);
      } // Default value


      if (this.values.has(name)) {
        field.setState({
          value: this.values.get(name)
        });
      }
    }
  }, {
    key: "get",
    value: function get(name) {
      return this.fields.get(name);
    }
  }, {
    key: "has",
    value: function has(name) {
      return this.fields.has(name);
    }
  }, {
    key: "remove",
    value: function remove(name) {
      this.fields.delete(name);
    }
  }, {
    key: "setError",
    value: function setError(name, error) {
      if (null === error) {
        this.errors.delete(name);
      } else {
        this.errors.set(name, error);
      }

      this.fields.get(name).setState({
        error: error
      });
    }
  }, {
    key: "setTouched",
    value: function setTouched(name, value) {
      this.touched.set(name, value);
    }
  }, {
    key: "setValue",
    value: function setValue(name, value) {
      value = value || null;
      this.values.set(name, value);

      if (this.fields.has(name)) {
        this.handleChange(name, value);
      }
    }
  }, {
    key: "getValue",
    value: function getValue(name) {
      if (!this.values.has(name)) {
        return null;
      }

      return this.values.get(name);
    }
  }, {
    key: "getError",
    value: function getError(name) {
      if (!this.errors.has(name)) {
        return null;
      }

      return this.errors.get(name);
    }
  }, {
    key: "getErrors",
    value: function getErrors() {
      return this.errors;
    }
  }, {
    key: "getTouched",
    value: function getTouched(name) {
      if (!this.touched.has(name)) {
        return null;
      }

      return this.touched.get(name);
    }
  }, {
    key: "getValues",
    value: function getValues() {
      return this.values;
    }
  }, {
    key: "handleChange",
    value: function () {
      var _handleChange = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(name, value) {
        var _this3 = this;

        var field, error, namesToCheck, isRequired;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                field = this.fields.get(name); // On normalize

                if (field.props.hasOwnProperty('onNormalize') && typeof field.props.onNormalize === 'function') {
                  value = field.props.onNormalize(value, field.state.value);
                  this.values.set(name, value);
                }

                if (!(value === field.state.value)) {
                  _context.next = 4;
                  break;
                }

                return _context.abrupt("return", false);

              case 4:
                // Touched
                this.touched.set(name, true); // Validation

                if (true === field.props.validateOnChange) {
                  error = this.handleValidate(name, value);

                  if (!error) {
                    this.errors.delete(name);
                  } else {
                    this.errors.set(name, error);
                  }
                } // On blur


                if (field.props.hasOwnProperty('onBlur') && typeof field.props.onBlur === 'function') {
                  field.props.onBlur(name, value, this.values.object);
                } // On blur if valid


                if (field.props.hasOwnProperty('onBlurIfValid') && typeof field.props.onBlurIfValid === 'function' && !this.errors.get(name)) {
                  field.props.onBlurIfValid(name, value, this.values.object);
                } // On change


                if (field.props.hasOwnProperty('onChange') && typeof field.props.onChange === 'function') {
                  field.props.onChange(name, value, this.values.object);
                } // On change if valid


                if (field.props.hasOwnProperty('onChangeIfValid') && typeof field.props.onChangeIfValid === 'function' && !this.errors.get(name)) {
                  field.props.onChangeIfValid(name, value, this.values.object);
                } // Disabled if not valid


                if (!this.fieldsTriggerDisabled.has(name)) {
                  _context.next = 13;
                  break;
                }

                _context.next = 13;
                return this.fieldsTriggerDisabled.get(name).forEach(function (nameToDisable) {
                  if (_this3.fieldsDisabledIfInvalid.has(nameToDisable)) {
                    var isValid = true;

                    _this3.fieldsDisabledIfInvalid.get(nameToDisable).forEach(function (nameToCheckValue) {
                      if (true === isValid && _this3.errors.has(nameToCheckValue)) {
                        isValid = false;
                      }
                    });

                    if (true === isValid) {
                      _this3.fields.get(nameToDisable).setState({
                        disabled: false
                      });
                    } else {
                      _this3.errors.delete(nameToDisable);

                      _this3.values.set(nameToDisable, '');

                      _this3.fields.get(nameToDisable).setState({
                        error: null,
                        disabled: true,
                        options: [],
                        value: ''
                      });
                    }
                  }
                });

              case 13:
                if (!this.fieldsRequiredIfNotEmpty.has(name)) {
                  _context.next = 19;
                  break;
                }

                namesToCheck = this.fieldsRequiredIfNotEmpty.get(name); // Is some field filled?

                isRequired = false;
                namesToCheck.forEach(function (nameToCheck) {
                  if (false === isRequired) {
                    if (!!_this3.values.get(nameToCheck)) {
                      isRequired = true;
                    }
                  }
                }); // Change state of fields

                _context.next = 19;
                return this.fieldsRequiredIfNotEmpty.forEach(function (field, nameToChange) {
                  if (_this3.fields.has(nameToChange)) {
                    var fieldToChange = _this3.fields.get(nameToChange);

                    if (fieldToChange.state.required !== isRequired) {
                      if (true === isRequired) {
                        fieldToChange.setState({
                          required: isRequired,
                          validatorsEnabled: isRequired
                        });
                      } else {
                        fieldToChange.setState({
                          error: null,
                          required: isRequired,
                          validatorsEnabled: isRequired
                        });
                      }
                    }
                  }
                });

              case 19:
                if (this.props.hasOwnProperty('onChange') && typeof this.props.onChange === 'function') {
                  this.props.onChange(this.values.object, name, value);
                }

                field.updateState();

              case 21:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function handleChange(_x, _x2) {
        return _handleChange.apply(this, arguments);
      };
    }()
  }, {
    key: "handleSubmit",
    value: function () {
      var _handleSubmit = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2(e) {
        var _this4 = this;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                e.preventDefault(e);
                _context2.next = 3;
                return this.setState({
                  isSubmitting: true
                });

              case 3:
                _context2.next = 5;
                return this.fields.forEach(function (field, name) {
                  var error = _this4.handleValidate(name, _this4.values.get(name));

                  _this4.setError(name, error);
                });

              case 5:
                if (!this.errors.empty()) {
                  _context2.next = 9;
                  break;
                }

                _context2.next = 8;
                return this.props.onSubmit(this.values.object);

              case 8:
                return _context2.abrupt("return");

              case 9:
                _context2.next = 11;
                return this.setState({
                  isHighlightingErrors: true,
                  isSubmitting: false
                });

              case 11:
                setTimeout(function () {
                  this.setState({
                    isHighlightingErrors: false
                  });
                }.bind(this), 500);

              case 12:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      return function handleSubmit(_x3) {
        return _handleSubmit.apply(this, arguments);
      };
    }()
  }, {
    key: "handleValidate",
    value: function handleValidate(name) {
      var _this5 = this;

      var value = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      var validateWithSkip = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      var error = null;
      var field = this.fields.get(name);

      if (false === field.state.validatorsEnabled) {
        return null;
      }

      if (field.state.visible) {
        value = value || '';
        field.props.validators.forEach(function (validator) {
          if (null === error) {
            error = validator.validate(value.trim(), _this5.getValues());
            field.props.validateIfChange.forEach(function (nameToValidate) {
              if (nameToValidate !== validateWithSkip && _this5.fields.has(nameToValidate)) {
                if (_this5.touched.has(nameToValidate)) {
                  var fieldError = _this5.handleValidate(nameToValidate, _this5.values.get(nameToValidate), name);

                  _this5.setError(nameToValidate, fieldError);
                }
              }
            });
          }
        });
      }

      return error;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          component = _this$props.component,
          render = _this$props.render,
          noValidate = _this$props.noValidate,
          onChange = _this$props.onChange,
          onInit = _this$props.onInit,
          onSubmit = _this$props.onSubmit,
          values = _this$props.values,
          rest = _objectWithoutProperties(_this$props, ["children", "component", "render", "noValidate", "onChange", "onInit", "onSubmit", "values"]);

      return React.createElement(FormContext.Provider, {
        value: this.formContext
      }, React.createElement(Form, _extends({}, rest, {
        className: this.formClassName,
        noValidate: noValidate,
        onChange: this.onChange,
        onSubmit: this.handleSubmit
      }), this.content));
    }
  }, {
    key: "formClassName",
    get: function get() {
      return this.state.isHighlightingErrors ? 'invalid-highlight' : null;
    }
  }, {
    key: "formContext",
    get: function get() {
      return {
        formApi: {
          get: this.get,
          getError: this.getError,
          getErrors: this.getErrors,
          getTouched: this.getTouched,
          getValue: this.getValue,
          getValues: this.getValues,
          has: this.has,
          isSubmitting: this.state.isSubmitting,
          remove: this.remove,
          set: this.set,
          setError: this.setError,
          setTouched: this.setTouched,
          setValue: this.setValue
        }
      };
    }
  }, {
    key: "content",
    get: function get() {
      var _this$props2 = this.props,
          children = _this$props2.children,
          component = _this$props2.component,
          render = _this$props2.render;
      var props = this.formContext;

      if (component) {
        return React.createElement(component, props, children);
      }

      if (render) {
        return render(props);
      }

      if (typeof children === 'function') {
        return children(props);
      }

      return children;
    }
  }]);

  return Form$$1;
}(React.Component);

Form$1.defaultProps = {
  noValidate: true,
  onChange: null,
  values: {}
};
Form$1.propTypes = {
  noValidate: PropTypes.bool,
  onInit: PropTypes.func,
  onChange: PropTypes.func,
  onSubmit: PropTypes.func.isRequired,
  values: PropTypes.object
};

var buildFieldApi = function buildFieldApi(formApi, name) {
  return {
    set: function set(field) {
      return formApi.set(name, field);
    },
    remove: function remove() {
      return formApi.remove(name);
    },
    getValue: function getValue() {
      return formApi.getValue(name);
    },
    setValue: function setValue(value) {
      return formApi.setValue(name, value);
    },
    getTouched: function getTouched() {
      return formApi.getTouched(name);
    },
    setTouched: function setTouched(value) {
      return formApi.setTouched(name, value);
    },
    getError: function getError() {
      return formApi.getError(name);
    },
    setError: function setError(value) {
      return formApi.setError(name, value);
    }
  };
};

var buildFieldState = function buildFieldState(formApi, name) {
  return {
    disabled: false,
    error: formApi.getError(name),
    touched: formApi.getTouched(name),
    required: false,
    visible: true,
    value: formApi.getValue(name)
  };
};

var withField = function withField(Component) {
  return withFormApi(
  /*#__PURE__*/
  function (_React$PureComponent) {
    _inherits(_class, _React$PureComponent);

    function _class(props) {
      var _this;

      _classCallCheck(this, _class);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(_class).call(this, props));
      var formApi = props.formApi,
          name = props.name;
      _this.fieldApi = buildFieldApi(formApi, name);
      _this.fieldState = buildFieldState(formApi, name); // Rebuild state when name changes

      _this.fieldStateUpdate = function () {
        console.log(_assertThisInitialized(_assertThisInitialized(_this)));

        _this.setState(buildFieldState(formApi, name));
      };

      return _this;
    }

    _createClass(_class, [{
      key: "render",
      value: function render() {
        var rest = _extends({}, this.props);

        return React.createElement(Component, _extends({
          fieldApi: this.fieldApi,
          fieldState: this.fieldState,
          fieldStateUpdate: this.fieldStateUpdate
        }, rest));
      }
    }]);

    return _class;
  }(React.PureComponent));
};

var withFieldApi = function withFieldApi(field) {
  return function (Component) {
    return withFormApi(function (_ref) {
      var formApi = _ref.formApi,
          props = _objectWithoutProperties(_ref, ["formApi"]);

      return React.createElement(Component, _extends({
        fieldApi: buildFieldApi(formApi, field)
      }, props));
    });
  };
};

var withFieldState = function withFieldState(field) {
  return function (Component) {
    return withFormApi(function (_ref2) {
      var formApi = _ref2.formApi,
          props = _objectWithoutProperties(_ref2, ["formApi"]);

      return React.createElement(Component, _extends({
        fieldState: buildFieldState(formApi, field)
      }, props));
    });
  };
};

export { Field$1 as Field, FieldAddonAppend, FieldAddonPrepend, FieldFeedback, FieldLabel, FieldText, Form$1 as Form, FormContext, withField, withFieldApi, withFieldState, withFormApi };
//# sourceMappingURL=lemo-form.es.js.map
